import { RoleUserEnum } from "../enum/RoleUserEnum";
import { TDeterminants } from "../type/TDeterminants";
import { ConnectionStateT } from "../type/ConnectionStateT";
import { DeviceT } from "../type/DeviceT";
import { IDeterminants } from "../interface/IDeterminants";
import { NetworkQuality } from "agora-rtc-sdk-ng";
import { WSTransport } from "../../transport/WSTransport";
export declare class Determinants implements IDeterminants {
    ConnectionState: ConnectionStateT;
    Updating: boolean;
    Role: RoleUserEnum;
    RoleIncoming: RoleUserEnum;
    HasAudio: boolean;
    HasCamera: boolean;
    HasScreen: boolean;
    HasProxy: boolean;
    Uid: number | string;
    AppId: string;
    Channel: string;
    ChannelIncoming: string;
    Muted: boolean;
    MicrophoneSelected: DeviceT;
    CameraSelected: DeviceT;
    PlayBackSelected: DeviceT;
    DeterminantsCallback: Function;
    Init: boolean;
    NetworkQuality: NetworkQuality;
    LoggerViewCallback: Function;
    volumenCallback: Function;
    userInformation: any;
    actionDispatch: Function;
    tranport: WSTransport;
    constructor(determinants?: TDeterminants);
    doDeterminatsCallback(): void;
    setDeterminantsCallback(value: Function): void;
    getDeterminantsCallback(): Function;
    getUid(): string | number;
    setUid(value: number | string): void;
    getHasScreen(): boolean;
    setHasScreen(value: boolean): void;
    getHasProxy(): boolean;
    setHasProxy(value: boolean): void;
    getHasCamera(): boolean;
    setHasCamera(value: boolean): void;
    getHasAudio(): boolean;
    setHasAudio(value: boolean): void;
    getUpdating(): boolean;
    setUpdating(value: boolean): void;
    getConnectionState(): ConnectionStateT;
    setConnectionState(value: ConnectionStateT): void;
    getAppId(): string;
    setAppId(value: string): void;
    getRole(): RoleUserEnum;
    setRole(value: RoleUserEnum): void;
    getChannel(): string | undefined;
    setChannel(value: string | undefined): void;
    getMuted(): boolean;
    setMuted(value: boolean): void;
    getMicrophoneSelected(): DeviceT;
    setMicrophoneSelected(value: DeviceT): void;
    getCameraSelected(): DeviceT;
    setCameraSelected(value: DeviceT): void;
    getPlayBackSelected(): DeviceT;
    setPlayBackSelected(value: DeviceT): void;
    getInit(): boolean;
    setInit(value: boolean): void;
    getLoggerViewCallback(): any;
    setLoggerViewCallback(value: any): void;
    getNetworkQuality(): NetworkQuality;
    setNetworkQuality(value: NetworkQuality): void;
    getVolumenCallback(): Function;
    setVolumenCallback(value: Function): void;
    setUserInformation(value: any): void;
    getUserInformation(): any;
    setActionDispatch(value: Function): void;
    getActionDispatch(): Function;
    setTranport(value: WSTransport): void;
    getTranport(): WSTransport;
    setChannelIncoming(value: string): void;
    getChannelIncoming(): string;
    setRoleIncoming(value: RoleUserEnum): void;
    getRoleIncoming(): RoleUserEnum;
}
