import { NetworkQuality } from "agora-rtc-sdk-ng";
import { WSTransport } from "../../transport/WSTransport";
import { RoleUserEnum } from "../enum/RoleUserEnum";
import { ConnectionStateT } from "../type/ConnectionStateT";
import { DeviceT } from "../type/DeviceT";
export interface IDeterminants {
    ConnectionState: ConnectionStateT;
    Updating: boolean;
    Role: RoleUserEnum;
    RoleIncoming?: RoleUserEnum;
    HasAudio: boolean;
    HasCamera: boolean;
    HasScreen: boolean;
    HasProxy: boolean;
    Uid?: number | string;
    AppId?: string;
    Channel?: string;
    ChannelIncoming?: string;
    Muted?: boolean;
    MicrophoneSelected?: DeviceT;
    CameraSelected?: DeviceT;
    PlayBackSelected?: DeviceT;
    Init?: boolean;
    NetworkQuality?: NetworkQuality;
    tranport?: WSTransport;
    volumenCallback?: Function;
    DeterminantsCallback?: Function;
    LoggerViewCallback?: Function;
    userInformation?: any;
    actionDispatch?: Function;
    getUid(): string | number;
    setUid(value: number): void;
    getHasScreen(): boolean;
    setHasScreen(value: boolean): void;
    getHasCamera(): boolean;
    setHasCamera(value: boolean): void;
    getHasAudio(): boolean;
    setHasAudio(value: boolean): void;
    getUpdating(): boolean;
    setUpdating(value: boolean): void;
    getConnectionState(): ConnectionStateT;
    setConnectionState(value: ConnectionStateT): void;
    getAppId(): string;
    setAppId(value: string): void;
    getRole(): RoleUserEnum;
    setRole(value: RoleUserEnum): void;
    getChannel(): string | undefined;
    setChannel(value: string | undefined): void;
    getMuted(): boolean;
    setMuted(value: boolean): void;
    getMicrophoneSelected(): DeviceT;
    setMicrophoneSelected(value: DeviceT): void;
    getCameraSelected(): DeviceT;
    setCameraSelected(value: DeviceT): void;
    getPlayBackSelected(): DeviceT;
    setPlayBackSelected(value: DeviceT): void;
    getDeterminantsCallback(): Function;
    setDeterminantsCallback(value: Function): void;
    getInit(): boolean;
    setInit(value: boolean): void;
    getLoggerViewCallback(): Function;
    setLoggerViewCallback(value: Function): void;
    getNetworkQuality(): NetworkQuality;
    setNetworkQuality(value: NetworkQuality): void;
    getVolumenCallback(): Function;
    setVolumenCallback(value: Function): void;
    getUserInformation(): any;
    setUserInformation(value: any): void;
    setActionDispatch(value: Function): void;
    getActionDispatch(): Function;
    getTranport(): WSTransport;
    setTranport(value: WSTransport): void;
    getChannelIncoming(): string;
    setChannelIncoming(value: string): void;
    getRoleIncoming(): RoleUserEnum;
    setRoleIncoming(value: RoleUserEnum): void;
}
