import { ClientConfig, IAgoraRTCClient, ICameraVideoTrack, ILocalVideoTrack, IMicrophoneAudioTrack } from "agora-rtc-sdk-ng";
import { Listeners } from "../listeners/Listeners";
export interface IResources {
    _configClient?: ClientConfig;
    _client?: IAgoraRTCClient;
    _listeners?: Listeners;
    _audioTrack?: IMicrophoneAudioTrack;
    _videoTrack?: ICameraVideoTrack;
    _screeanTrack?: ILocalVideoTrack;
    _resourcesCallback?: Function;
    _volumenCallback?: Function;
    _volumenInterval?: Function;
    getMicrophones(): Promise<MediaDeviceInfo[]>;
    getSpeakers(): Promise<MediaDeviceInfo[]>;
    getCameras(): Promise<MediaDeviceInfo[]>;
    getAudioTrack(): IMicrophoneAudioTrack;
    setAudioTrack(value: IMicrophoneAudioTrack): void;
    getVideoTrack(): ICameraVideoTrack;
    setVideoTrack(value: ICameraVideoTrack): void;
    getScreeanTrack(): ILocalVideoTrack;
    setScreeanTrack(value: ILocalVideoTrack): void;
    getClient(): IAgoraRTCClient;
    setClient(value: IAgoraRTCClient): void;
    getListeners(): Listeners;
    getConfigClient(): ClientConfig;
    setConfigClient(value: ClientConfig): void;
    getResourcesCallback(): Function;
    setResourcesCallback(value: Function): void;
    getVolumenCallback(): Function;
    setVolumenCallback(value: Function): void;
    startRecordVolumen(): void;
    stopRecordVolumen(): void;
}
