import { ListenerEnum } from "../enum/ListenerEnum";
var Listeners = /** @class */ (function () {
    function Listeners(client) {
        this._readyCallback = false;
        this._client = client;
    }
    Listeners.prototype.isReadyCallbacks = function () {
        return this._readyCallback;
    };
    Listeners.prototype.setReadyCallbacks = function (ready) {
        this._readyCallback = ready;
    };
    Listeners.prototype.userJoined = function (callback) {
        this._client.on(ListenerEnum.UserJoined, callback);
    };
    Listeners.prototype.userLeft = function (callback) {
        this._client.on(ListenerEnum.UserLeft, callback);
    };
    Listeners.prototype.userPublished = function (callback) {
        this._client.on(ListenerEnum.UserPublished, callback);
    };
    Listeners.prototype.userUnpublished = function (callback) {
        this._client.on(ListenerEnum.UserUnpublished, callback);
    };
    Listeners.prototype.connectionState = function (callback) {
        this._client.on(ListenerEnum.ConnectionStateChanged, callback);
    };
    Listeners.prototype.joinFallbackToProxy = function (callback) {
        this._client.on(ListenerEnum.JoinFallbackToProxy, callback);
    };
    Listeners.prototype.networkQuality = function (callback) {
        this._client.on(ListenerEnum.NetworkQuality, callback);
    };
    return Listeners;
}());
export { Listeners };
