import { ClientConfig, IAgoraRTCClient, ICameraVideoTrack, ILocalVideoTrack, IMicrophoneAudioTrack } from "agora-rtc-sdk-ng";
import { IResources } from "../interface/IResources";
import { Listeners } from "../listeners/Listeners";
import { DeviceT } from "../type/DeviceT";
import { TResources } from "../type/TResources";
export declare class Resources implements IResources {
    _configClient: ClientConfig;
    _client: IAgoraRTCClient;
    _listeners: Listeners;
    _audioTrack: IMicrophoneAudioTrack;
    _videoTrack: ICameraVideoTrack;
    _screeanTrack: ILocalVideoTrack;
    _resourcesCallback: Function;
    _volumenCallback: Function;
    _volumenInterval: Function;
    constructor(resources?: TResources);
    doResourcesCallback(): void;
    getMicrophones(): Promise<MediaDeviceInfo[]>;
    getSpeakers(): Promise<MediaDeviceInfo[]>;
    getCameras(): Promise<MediaDeviceInfo[]>;
    getAudioTrack(): IMicrophoneAudioTrack;
    createAudioTrack(microphoneSelected: DeviceT, encoderConfig?: any): Promise<IMicrophoneAudioTrack>;
    hasDevicePermissions(): Promise<boolean>;
    setAudioTrack(value: IMicrophoneAudioTrack): void;
    getVideoTrack(): ICameraVideoTrack;
    createVideoTrack(cameraSelected: DeviceT, encoderConfig?: any): Promise<ICameraVideoTrack>;
    setVideoTrack(value: ICameraVideoTrack): void;
    getScreeanTrack(): ILocalVideoTrack;
    createScreenTrack(encoderConfig?: any): Promise<ILocalVideoTrack>;
    setScreeanTrack(value: ILocalVideoTrack): void;
    getClient(): IAgoraRTCClient;
    setClient(value: IAgoraRTCClient): void;
    getListeners(): Listeners;
    setListeners(value: Listeners): void;
    getConfigClient(): ClientConfig;
    setConfigClient(value: ClientConfig): void;
    getResourcesCallback(): Function;
    setResourcesCallback(value: Function): void;
    getVolumenCallback(): Function;
    setVolumenCallback(value: Function): void;
    startRecordVolumen(volumenCallback: Function): void;
    stopRecordVolumen(): void;
}
