var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import AgoraRTC from "agora-rtc-sdk-ng";
import { resolve } from "path";
var Resources = /** @class */ (function () {
    function Resources(resources) {
        this._configClient = { codec: "vp8", mode: "live" };
        if (resources) {
            if (resources._configClient)
                this._configClient = resources._configClient;
            if (resources._client)
                this._client = resources._client;
            if (resources._listeners)
                this._listeners = resources._listeners;
            if (resources._audioTrack)
                this._audioTrack = resources._audioTrack;
            if (resources._videoTrack)
                this._videoTrack = resources._videoTrack;
            if (resources._screeanTrack)
                this._screeanTrack = resources._screeanTrack;
            if (resources._resourcesCallback)
                this._resourcesCallback = resources._resourcesCallback;
            if (resources._volumenCallback)
                this._resourcesCallback = resources._volumenCallback;
            if (resources._volumenInterval)
                this._volumenInterval = resources._volumenInterval;
        }
    }
    Resources.prototype.doResourcesCallback = function () {
        if (this._resourcesCallback) {
            this.getResourcesCallback()(this);
        }
    };
    Resources.prototype.getMicrophones = function () {
        return __awaiter(this, void 0, void 0, function () {
            var devices, microphones;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, AgoraRTC.getDevices()];
                    case 1:
                        devices = _a.sent();
                        if (devices.length == 0)
                            return [2 /*return*/, []];
                        microphones = devices.filter(function (device) { return device.kind === "audioinput"; });
                        return [2 /*return*/, microphones];
                }
            });
        });
    };
    Resources.prototype.getSpeakers = function () {
        return __awaiter(this, void 0, void 0, function () {
            var devices, speakers;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, AgoraRTC.getDevices()];
                    case 1:
                        devices = _a.sent();
                        if (devices.length == 0)
                            return [2 /*return*/, []];
                        speakers = devices.filter(function (device) { return device.kind === "audiooutput"; });
                        return [2 /*return*/, speakers];
                }
            });
        });
    };
    Resources.prototype.getCameras = function () {
        return __awaiter(this, void 0, void 0, function () {
            var devices, cameras;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, AgoraRTC.getDevices()];
                    case 1:
                        devices = _a.sent();
                        if (devices.length == 0)
                            return [2 /*return*/, []];
                        cameras = devices.filter(function (device) { return device.kind === "videoinput"; });
                        return [2 /*return*/, cameras];
                }
            });
        });
    };
    Resources.prototype.getAudioTrack = function () {
        return this._audioTrack;
    };
    Resources.prototype.createAudioTrack = function (microphoneSelected, encoderConfig) {
        return __awaiter(this, void 0, void 0, function () {
            var audioParams, track;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        audioParams = {
                            AEC: true,
                            AGC: false,
                            ANS: true,
                            encoderConfig: "music_standard",
                            microphoneId: microphoneSelected.deviceId,
                        };
                        return [4 /*yield*/, AgoraRTC.createMicrophoneAudioTrack(audioParams)];
                    case 1:
                        track = _a.sent();
                        this.setAudioTrack(track);
                        return [2 /*return*/, track];
                }
            });
        });
    };
    Resources.prototype.hasDevicePermissions = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function () { return __awaiter(_this, void 0, void 0, function () {
                        var client, microphones, error_1;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (!this._client) return [3 /*break*/, 1];
                                    client = this._client;
                                    return [3 /*break*/, 3];
                                case 1: return [4 /*yield*/, AgoraRTC.createClient(this.getConfigClient())];
                                case 2:
                                    client = _a.sent();
                                    _a.label = 3;
                                case 3:
                                    _a.trys.push([3, 8, , 9]);
                                    return [4 /*yield*/, this.getMicrophones()];
                                case 4:
                                    microphones = _a.sent();
                                    if (!(microphones && microphones.length > 0)) return [3 /*break*/, 6];
                                    return [4 /*yield*/, this.createAudioTrack(microphones[0])];
                                case 5:
                                    _a.sent();
                                    return [3 /*break*/, 7];
                                case 6:
                                    resolve(false);
                                    _a.label = 7;
                                case 7: return [3 /*break*/, 9];
                                case 8:
                                    error_1 = _a.sent();
                                    resolve(false);
                                    return [3 /*break*/, 9];
                                case 9:
                                    resolve(true);
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
            });
        });
    };
    Resources.prototype.setAudioTrack = function (value) {
        this._audioTrack = value;
        this.doResourcesCallback();
    };
    Resources.prototype.getVideoTrack = function () {
        return this._videoTrack;
    };
    Resources.prototype.createVideoTrack = function (cameraSelected, encoderConfig) {
        return __awaiter(this, void 0, void 0, function () {
            var cameras, videoParams, track;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getCameras()];
                    case 1:
                        cameras = _a.sent();
                        videoParams = {
                            facingMode: "user",
                            encoderConfig: {
                                width: 640,
                                height: 480,
                                frameRate: 30,
                                bitrateMin: 400,
                                bitrateMax: 990
                            },
                            optimizationMode: "motion",
                            cameraId: cameraSelected ? cameraSelected.deviceId : cameras && cameras.length > 0 ? cameras[0].deviceId : undefined,
                        };
                        return [4 /*yield*/, AgoraRTC.createCameraVideoTrack(videoParams)];
                    case 2:
                        track = _a.sent();
                        this.setVideoTrack(track);
                        return [2 /*return*/, track];
                }
            });
        });
    };
    Resources.prototype.setVideoTrack = function (value) {
        this._videoTrack = value;
        this.doResourcesCallback();
    };
    Resources.prototype.getScreeanTrack = function () {
        return this._screeanTrack;
    };
    Resources.prototype.createScreenTrack = function (encoderConfig) {
        return __awaiter(this, void 0, void 0, function () {
            var videoParams, track;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        videoParams = {
                            encoderConfig: {
                                width: 1920,
                                height: 1080,
                                frameRate: 30,
                                bitrateMin: 2080,
                                bitrateMax: 3160
                            },
                            optimizationMode: "detail",
                        };
                        return [4 /*yield*/, AgoraRTC.createScreenVideoTrack(videoParams, "disable")];
                    case 1:
                        track = _a.sent();
                        this.setScreeanTrack(track);
                        return [2 /*return*/, track];
                }
            });
        });
    };
    Resources.prototype.setScreeanTrack = function (value) {
        this._screeanTrack = value;
        this.doResourcesCallback();
    };
    Resources.prototype.getClient = function () {
        return this._client;
    };
    Resources.prototype.setClient = function (value) {
        this._client = value;
        this.doResourcesCallback();
    };
    Resources.prototype.getListeners = function () {
        return this._listeners;
    };
    Resources.prototype.setListeners = function (value) {
        this._listeners = value;
        this.doResourcesCallback();
    };
    Resources.prototype.getConfigClient = function () {
        return this._configClient;
    };
    Resources.prototype.setConfigClient = function (value) {
        this._configClient = value;
        this.doResourcesCallback();
    };
    Resources.prototype.getResourcesCallback = function () {
        return this._resourcesCallback;
    };
    Resources.prototype.setResourcesCallback = function (value) {
        this._resourcesCallback = value;
    };
    Resources.prototype.getVolumenCallback = function () {
        return this._volumenCallback;
    };
    Resources.prototype.setVolumenCallback = function (value) {
        this._volumenCallback = value;
    };
    Resources.prototype.startRecordVolumen = function (volumenCallback) {
        var _this = this;
        this._volumenInterval = setInterval(function () {
            if (volumenCallback && _this._audioTrack) {
                volumenCallback(_this._audioTrack.getVolumeLevel());
            }
        }, 500);
    };
    Resources.prototype.stopRecordVolumen = function () {
        clearInterval(this._volumenInterval);
    };
    return Resources;
}());
export { Resources };
