var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { ErrorType } from "./enum/ErrorType";
var parseError = require('parse-error');
import { BaseError } from "./base/BaseError";
import { AgoraError } from "./AgoraError";
import { ErrorTitles } from "./enum/ErrorTitles";
var CustomError = /** @class */ (function (_super) {
    __extends(CustomError, _super);
    function CustomError(type, title, message) {
        return _super.call(this, type, title, message) || this;
    }
    CustomError.parseCustomError = function (error) {
        var customError = [];
        try {
            if (error instanceof CustomError) {
                //When error instance is create in code
                error.setType(ErrorType.GENERAL);
                customError.push(error);
            }
            else if (error && error.errors) {
                //when error result in fails validation rules
                if (error.errors) {
                    var arrErrors = Object.values(error.errors);
                    arrErrors.forEach(function (errorItem) {
                        if (errorItem.length > 0) {
                            errorItem.forEach(function (err) {
                                if (err.length > 0) {
                                    customError.push(new CustomError(ErrorType.BUSINESS, ErrorTitles.BusinessRuleError, err));
                                }
                            });
                        }
                    });
                }
            }
            else {
                error = parseError(error);
                if (error.type && error.message) {
                    //When error instance is create by try cacth in agora operations
                    var agoraErrors = AgoraError.parseCustomError(error);
                    for (var index = 0; index < agoraErrors.length; index++) {
                        var error_1 = agoraErrors[index];
                        customError.push(error_1);
                    }
                }
            }
        }
        catch (error) {
            customError.push(new CustomError(ErrorType.GENERAL, ErrorTitles.UnknownError, "unknown error"));
        }
        return customError;
    };
    return CustomError;
}(BaseError));
export { CustomError };
