export var AgoraReasonErrors = [
    {
        "code": "PERMISSION_DENIED_BY_SYSTEM",
        "notifiable": true,
        "reason": "Possibly you have permissions in the browser but the operating system is denying access to devices."
    },
    {
        "code": "NOT_READABLE",
        "notifiable": true,
        "reason": "Although the user granted device permission, access to the media device is prevented."
    },
    {
        "code": "UNEXPECTED_ERROR",
        "notifiable": false,
        "reason": "Unexpected error that the SDK cannot handle."
    },
    {
        "code": "UNEXPECTED_RESPONSE",
        "notifiable": true,
        "reason": "The state is inconsistent with streaming servers due to poor network conditions."
    },
    {
        "code": "INVALID_PARAMS",
        "notifiable": false,
        "reason": "	Incorrect parameter."
    },
    {
        "code": "NOT_SUPPORTED",
        "notifiable": true,
        "reason": "Not supported by the browser."
    },
    {
        "code": "INVALID_OPERATION",
        "notifiable": false,
        "reason": "Illegal operation, usually because you cannot perform this operation in the current state."
    },
    {
        "code": "OPERATION_ABORTED",
        "notifiable": false,
        "reason": "The operation is aborted because there fails to communicate with streaming servers due to poor network conditions or disconnection."
    },
    {
        "code": "WEB_SECURITY_RESTRICT",
        "notifiable": true,
        "reason": "Browser security policy restrictions."
    },
    {
        "code": "NO_ACTIVE_STATUS",
        "notifiable": true,
        "reason": "Your project is not active or disabled."
    },
    {
        "code": "NETWORK_TIMEOUT",
        "notifiable": true,
        "reason": "Timeout because to communicate with streaming servers due to poor network conditions or disconnection."
    },
    {
        "code": "NETWORK_RESPONSE_ERROR",
        "notifiable": true,
        "reason": "An error occurs in the server response, by a incorrect parameter."
    },
    {
        "code": "NETWORK_ERROR",
        "notifiable": true,
        "reason": "Fails to locate the network error."
    },
    {
        "code": "WS_ABORT",
        "notifiable": true,
        "reason": "Disconnected when tried requested connecting the audio streaming servers."
    },
    {
        "code": "WS_DISCONNECT",
        "notifiable": true,
        "reason": "Disconnected before requesting link for the audio streaming servers"
    },
    {
        "code": "WS_ERR",
        "notifiable": true,
        "reason": "Connection error to audio streaming servers."
    },
    {
        "code": "ENUMERATE_DEVICES_FAILED",
        "notifiable": true,
        "reason": "Fails to enumerate local devices, usually due to browser restrictions."
    },
    {
        "code": "DEVICE_NOT_FOUND",
        "notifiable": true,
        "reason": "Fails to find the specified device."
    },
    {
        "code": "TRACK_IS_DISABLED",
        "notifiable": true,
        "reason": "The track audio/video is disabled."
    },
    {
        "code": "SHARE_AUDIO_NOT_ALLOWED",
        "notifiable": true,
        "reason": "No audio sharing when screen video was shared."
    },
    {
        "code": "CHROME_PLUGIN_NO_RESPONSE",
        "notifiable": true,
        "reason": "No response from Audio/Video Chrome Extension for Screen Sharing."
    },
    {
        "code": "CHROME_PLUGIN_NOT_INSTALL",
        "notifiable": true,
        "reason": "	Audio/Video Chrome Extension for Screen Sharing has not been installed."
    },
    {
        "code": "MEDIA_OPTION_INVALID",
        "notifiable": true,
        "reason": "Invalid parameter for audio/video capturing."
    },
    {
        "code": "CONSTRAINT_NOT_SATISFIED",
        "notifiable": true,
        "reason": "Invalid parameter for audio/video capturing."
    },
    {
        "code": "PERMISSION_DENIED",
        "notifiable": true,
        "reason": "Fails to get access to the media device."
    },
    {
        "code": "FETCH_AUDIO_FILE_FAILED",
        "notifiable": false,
        "reason": "Fails to download the online audio file."
    },
    {
        "code": "READ_LOCAL_AUDIO_FILE_ERROR",
        "notifiable": false,
        "reason": "Fails to read the local audio file."
    },
    {
        "code": "DECODE_AUDIO_FILE_FAILED",
        "notifiable": false,
        "reason": "Fails to decode the audio file mainly because the codec of the audio file is not supported by WebAudio."
    },
    {
        "code": "UID_CONFLICT",
        "notifiable": true,
        "reason": "User session duplication. close the other sessions."
    },
    {
        "code": "INVALID_UINT_UID_FROM_STRING_UID",
        "notifiable": false,
        "reason": "Agora's service for allocating a UID returns an illegal number for UID."
    },
    {
        "code": "CAN_NOT_GET_PROXY_SERVER",
        "notifiable": true,
        "reason": "Fails to connect the cloud proxy service."
    },
    {
        "code": "CAN_NOT_GET_GATEWAY_SERVER",
        "notifiable": true,
        "reason": "Fails to connect the audio streaming servers."
    },
    {
        "code": "INVALID_LOCAL_TRACK",
        "notifiable": false,
        "reason": "The LocalTrack object that you pass is illegal."
    },
    {
        "code": "CAN_NOT_PUBLISH_MULTIPLE_VIDEO_TRACKS",
        "notifiable": true,
        "reason": "You can't publish Camera and screeen at the same time."
    },
    {
        "code": "INVALID_REMOTE_USER",
        "notifiable": false,
        "reason": "The remote user may not be in the channel or have not yet published any tracks."
    },
    {
        "code": "REMOTE_USER_IS_NOT_PUBLISHED",
        "notifiable": false,
        "reason": "The remote user has not yet published a track of the media type that you specify."
    },
    {
        "code": "LIVE_STREAMING_TASK_CONFLICT",
        "notifiable": false,
        "reason": "The streaming task exists."
    },
    {
        "code": "LIVE_STREAMING_INVALID_ARGUMENT",
        "notifiable": false,
        "reason": "Incorrect streaming parameters."
    },
    {
        "code": "LIVE_STREAMING_INTERNAL_SERVER_ERROR",
        "notifiable": false,
        "reason": "An internal error occurs in the dedicated Agora server for pushing streams."
    },
    {
        "code": "LIVE_STREAMING_CDN_ERROR",
        "notifiable": false,
        "reason": "An error occurs in the target CDN."
    },
    {
        "code": "LIVE_STREAMING_INVALID_RAW_STREAM",
        "notifiable": false,
        "reason": "Timed out when trying to connect with live streaming"
    },
    {
        "code": "CROSS_CHANNEL_WAIT_STATUS_ERROR",
        "notifiable": false,
        "reason": "An error occurred when triggering the channel-media-relay-state."
    },
    {
        "code": "CROSS_CHANNEL_FAILED_JOIN_SRC",
        "notifiable": false,
        "reason": "Fails to send the relay request."
    },
    {
        "code": "CROSS_CHANNEL_FAILED_JOIN_DEST",
        "notifiable": false,
        "reason": "Fails to accept the relay request."
    },
    {
        "code": "CROSS_CHANNEL_FAILED_PACKET_SENT_TO_DEST",
        "notifiable": false,
        "reason": "The streaming server fails to receive the media stream."
    },
    {
        "code": "CROSS_CHANNEL_SERVER_ERROR_RESPONSE",
        "notifiable": false,
        "reason": "An error occurs in the server response."
    },
];
