var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { useState, useEffect } from 'react';
import AgoraRTC from 'agora-rtc-sdk-ng';
import { InitAction } from '../action/InitAction';
import { Determinants } from "../context/determinants/Determinants";
import { useSelector, useDispatch } from 'react-redux';
import { setContext } from '../store/slices/context';
import { Resources } from '../context/resources/Resources';
import { setAction, deleteActionById, increaseIntent, clearAction } from '../store/slices/action';
import { IntervalWorker } from '../worker/IntervalWorker';
import { WSTransport } from '../transport/WSTransport';
import { RegionChangeAction } from '../action/RegionChangeAction';
import { ConnectionStatesEnum } from '../context/enum/ConnectionStates';
import { ActiveProxyAction } from '../action/ActiveProxyAction';
import { DisconnectAction } from '../action/DisconnectAction';
import { ToggleVoiceAction } from '../action/ToggleVoiceAction';
import { ChangeDeviceAction } from '../action/ChangeDeviceAction';
import { SubscribeAction } from '../action/SubscribeAction';
import { MediaTypeEnum } from '../context/enum/MediaTypeEnum';
import { UnsubscribeAction } from '../action/UnsubscribeAction';
import { ShareCameraAction } from '../action/ShareCameraAction';
import { ShareScreenAction } from '../action/ShareScreenAction';
import { ChangeRoleAction } from '../action/ChangeRoleAction';
import { ChangeModuleConfigAction } from '../action/ChangeModuleConfigAction';
import { EActionPriorityType } from '../action/enum/EActionPriorityType';
export function ActionsHook() {
    var _this = this;
    var reintenTimeProxyFailBack = 3000;
    var dispatch = useDispatch();
    var AgoraContext = useSelector(function (state) { return state.context; }).context;
    var actions = useSelector(function (state) { return state.action; }).action;
    var _a = useState(0), contextUpdating = _a[0], setContextUpdating = _a[1];
    var _b = useState(false), cameraSharing = _b[0], setCameraSharing = _b[1];
    var _c = useState(false), screenSharing = _c[0], setScreenSharing = _c[1];
    var _d = useState(), determinants = _d[0], setDeterminants = _d[1];
    var _e = useState(), actionDeleteId = _e[0], setActionDeleteId = _e[1];
    var _f = useState(), actionReintentId = _f[0], setActionReintentId = _f[1];
    var _g = useState(), resources = _g[0], setResources = _g[1];
    var _h = useState(new IntervalWorker(AgoraContext)), Worker = _h[0], setWorker = _h[1];
    var _j = useState(new Array()), microphones = _j[0], setMicrophones = _j[1];
    var _k = useState(new Array()), cameras = _k[0], setCameras = _k[1];
    var _l = useState(new Array()), speakers = _l[0], setSpeakers = _l[1];
    var _m = useState(false), handlerErrorProxy = _m[0], setHandlerErrorProxy = _m[1];
    var _o = useState(false), initiated = _o[0], setInitiated = _o[1];
    AgoraRTC.onMicrophoneChanged = function (changedDevice) { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            getDevices();
            return [2 /*return*/];
        });
    }); };
    /* DELETE ACTIONS BY WORKER*/
    useEffect(function () {
        if (actionDeleteId) {
            var id = actionDeleteId.split(":");
            dispatch(deleteActionById({ id: id[0] }));
        }
    }, [actionDeleteId]);
    /* DELETE REINTENT BY WORKER*/
    useEffect(function () {
        if (actionReintentId) {
            var id = actionReintentId.split(":");
            dispatch(increaseIntent({ id: id[0] }));
        }
    }, [actionReintentId]);
    /* SETUP DEVICES*/
    useEffect(function () {
        getDevices();
    }, []);
    /* SETUP DISPATCH ACTIONS*/
    useEffect(function () {
        AgoraContext.getDeterminants().setActionDispatch(dispatch);
    }, []);
    /* SETUP and RUN WORKER*/
    useEffect(function () {
        Worker.setReintentActionCallback(setActionReintentId);
        Worker.setDeleteActionCallback(setActionDeleteId);
        Worker.run();
    }, []);
    /* UPDATE ACTION TO WORKER*/
    useEffect(function () {
        Worker.setActions(actions);
    }, [actions]);
    /* SETUP CALLBACKS TO UPDATE CONTEXT*/
    useEffect(function () {
        AgoraContext.getDeterminants().setDeterminantsCallback(setDeterminants);
        AgoraContext.getResources().setResourcesCallback(setResources);
        dispatch(setContext({ context: AgoraContext }));
    }, [AgoraContext]);
    /* UPDATE CONTEXT-DETERMINANTS IN REDUX*/
    useEffect(function () {
        if (determinants) {
            var newDeterminants = new Determinants(determinants);
            AgoraContext.setDeterminants(newDeterminants);
            Worker.setContext(AgoraContext);
            dispatch(setContext({ context: AgoraContext }));
            setContextUpdating(Date.now());
            if (AgoraContext.getDeterminants().getHasCamera())
                setCameraSharing(true);
            else
                setCameraSharing(false);
            if (AgoraContext.getDeterminants().getHasScreen())
                setScreenSharing(true);
            else
                setScreenSharing(false);
            if (AgoraContext.getDeterminants().getInit())
                setInitiated(true);
            else
                setInitiated(false);
        }
    }, [determinants]);
    /* UPDATE CONTEXT-RESOURCES IN REDUX*/
    useEffect(function () {
        if (resources) {
            var newResources = new Resources(resources);
            AgoraContext.setResources(newResources);
            if (AgoraContext.getResources().getListeners() && !AgoraContext.getResources().getListeners().isReadyCallbacks()) {
                AgoraContext.getResources().getListeners().connectionState(contectionState);
                AgoraContext.getResources().getListeners().userJoined(userJoined);
                AgoraContext.getResources().getListeners().userLeft(userLeft);
                AgoraContext.getResources().getListeners().userPublished(userPublished);
                AgoraContext.getResources().getListeners().userUnpublished(userUnpublished);
                AgoraContext.getResources().getListeners().joinFallbackToProxy(joinFallbackToProxy);
                AgoraContext.getResources().getListeners().networkQuality(networkQuality);
                AgoraContext.getResources().getListeners().setReadyCallbacks(true);
            }
            Worker.setContext(AgoraContext);
            dispatch(setContext({ context: AgoraContext }));
            setContextUpdating(Date.now());
        }
    }, [resources]);
    /*
        * CALLBACKS AGORA LISTENERS
    */
    var contectionState = function (curState, revState, reason) {
        AgoraContext.getDeterminants().setConnectionState({ curState: curState, revState: revState, reason: reason });
    };
    var userJoined = function (user) {
    };
    var userLeft = function (user, reason) {
    };
    var userPublished = function (user, mediaType) {
        var mediaTypeValue = mediaType == MediaTypeEnum.AUDIO ? MediaTypeEnum.AUDIO : MediaTypeEnum.VIDEO;
        var params = { remoteUser: user, mediaType: mediaTypeValue, uid: user.uid };
        var action = new SubscribeAction(params);
        console.log("[AgoraModule] - push SubscribeAction ", action);
        dispatch(setAction({ action: action }));
    };
    var userUnpublished = function (user, mediaType) {
        var mediaTypeValue = mediaType == MediaTypeEnum.AUDIO ? MediaTypeEnum.AUDIO : MediaTypeEnum.VIDEO;
        var params = { remoteUser: user, mediaType: mediaTypeValue, uid: user.uid };
        var action = new UnsubscribeAction(params);
        console.log("[AgoraModule] - push UnsubscribeAction ", action);
        dispatch(setAction({ action: action }));
    };
    var joinFallbackToProxy = function (proxyServer) {
        if (!handlerErrorProxy) {
            setTimeout(function () {
                if (AgoraContext.getDeterminants().getConnectionState().curState == ConnectionStatesEnum.CONNECTING) {
                    Disconnect(EActionPriorityType.SUPER_LIFO);
                    ActiveProxy();
                    setHandlerErrorProxy(false);
                }
            }, reintenTimeProxyFailBack);
            setHandlerErrorProxy(true);
        }
    };
    var networkQuality = function (NetworkQuality) {
        AgoraContext.getDeterminants().setNetworkQuality(NetworkQuality);
    };
    /*
        * ACTIONS TO EXPOSE
    */
    function Init() {
        var params = { init: true };
        var action = new InitAction(params);
        console.log("[AgoraModule] - push InitAction ", action);
        dispatch(setAction({ action: action }));
    }
    function RegionChange(channel, role, requiredConfirm, keepTracks) {
        var params = { channel: channel, role: role };
        if (keepTracks != undefined || keepTracks != null) {
            params.keepTracks = keepTracks;
        }
        else {
            params.keepTracks = false;
        }
        if (requiredConfirm != undefined || requiredConfirm != null) {
            params.requiredConfirm = requiredConfirm;
        }
        else {
            params.requiredConfirm = false;
        }
        ;
        var action = new RegionChangeAction(params);
        console.log("[AgoraModule] - push RegionChangeAction ", action);
        dispatch(setAction({ action: action }));
    }
    function ReJoin(channel, role) {
        dispatch(clearAction());
        setTimeout(function () {
            Disconnect(EActionPriorityType.SUPER_LIFO);
            if (channel && role) {
                RegionChange(channel, role, true, true);
            }
            else {
                RegionChange(AgoraContext.getDeterminants().ChannelIncoming, AgoraContext.getDeterminants().RoleIncoming, true, true);
            }
        }, 300);
    }
    function ActiveProxy() {
        var params = { type: 3 };
        var action = new ActiveProxyAction(params);
        console.log("[AgoraModule] - push ActiveProxyAction ", action);
        dispatch(setAction({ action: action }));
    }
    function Disconnect(priority) {
        var params = { datetime: Date.now(), priority: priority ? priority : EActionPriorityType.SUPER_LIFO };
        var action = new DisconnectAction(params);
        console.log("[AgoraModule] - push DisconnectAction ", action);
        dispatch(setAction({ action: action }));
    }
    function ToggleVoice(mute) {
        var params = { action: mute != undefined ? mute : !AgoraContext.getDeterminants().getMuted() };
        var action = new ToggleVoiceAction(params);
        console.log("[AgoraModule] - push ToggleVoiceAction ", action);
        dispatch(setAction({ action: action }));
    }
    function ChangeDevice(type, device) {
        var params = { device: device, type: type };
        var action = new ChangeDeviceAction(params);
        console.log("[AgoraModule] - push ChangeDeviceAction ", action);
        dispatch(setAction({ action: action }));
    }
    function ShareCamera(active) {
        var params = { active: active != undefined ? active : !AgoraContext.getDeterminants().getHasCamera() };
        var action = new ShareCameraAction(params);
        console.log("[AgoraModule] - push ShareCameraAction ", action);
        dispatch(setAction({ action: action }));
    }
    function ShareScreen(active) {
        var params = { active: active != undefined ? active : !AgoraContext.getDeterminants().getHasScreen() };
        var action = new ShareScreenAction(params);
        console.log("[AgoraModule] - push ShareScreenAction ", action);
        dispatch(setAction({ action: action }));
    }
    function ChangeRole(role) {
        var params = { role: role };
        var action = new ChangeRoleAction(params);
        console.log("[AgoraModule] - push ChangeRoleAction ", action);
        dispatch(setAction({ action: action }));
    }
    function ChangeModuleConfig(app_id, uid, user, client_config) {
        var params = {};
        if (app_id)
            params.app_id = app_id;
        if (uid)
            params.uid = uid;
        if (user)
            params.user = user;
        if (client_config)
            params.client_config = client_config;
        var action = new ChangeModuleConfigAction(params);
        console.log("[AgoraModule] - push ChangeModuleConfigAction ", action);
        dispatch(setAction({ action: action }));
    }
    /*TO SETUP CALLBACK LOGGER VIEW*/
    function setLoggerExpose(value) {
        AgoraContext.getDeterminants().setLoggerViewCallback(value);
        dispatch(setContext({ context: AgoraContext }));
    }
    /*TO SETUP INSTANCE TRANSPORT*/
    function setTransportExpose(value) {
        AgoraContext.getDeterminants().setTranport(new WSTransport(value));
    }
    /*TO SETUP CALLBACK VOLUMEN*/
    function setVolumenExpose(value) {
        AgoraContext.getDeterminants().setVolumenCallback(value);
        dispatch(setContext({ context: AgoraContext }));
    }
    function getDevices() {
        return __awaiter(this, void 0, void 0, function () {
            var microphones_1, cameras_1, speakers_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!AgoraContext.getResources()) return [3 /*break*/, 4];
                        return [4 /*yield*/, AgoraContext.getResources().getMicrophones()];
                    case 1:
                        microphones_1 = _a.sent();
                        return [4 /*yield*/, AgoraContext.getResources().getCameras()];
                    case 2:
                        cameras_1 = _a.sent();
                        return [4 /*yield*/, AgoraContext.getResources().getSpeakers()];
                    case 3:
                        speakers_1 = _a.sent();
                        setMicrophones(microphones_1);
                        setCameras(cameras_1);
                        setSpeakers(speakers_1);
                        _a.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
    return {
        Init: Init,
        RegionChange: RegionChange,
        ReJoin: ReJoin,
        ActiveProxy: ActiveProxy,
        Disconnect: Disconnect,
        ToggleVoice: ToggleVoice,
        ChangeDevice: ChangeDevice,
        ShareCamera: ShareCamera,
        ShareScreen: ShareScreen,
        ChangeRole: ChangeRole,
        ChangeModuleConfig: ChangeModuleConfig,
        AgoraContext: AgoraContext,
        Worker: Worker,
        setLoggerExpose: setLoggerExpose,
        setTransportExpose: setTransportExpose,
        setVolumenExpose: setVolumenExpose,
        microphones: microphones,
        cameras: cameras,
        speakers: speakers,
        contextUpdating: contextUpdating,
        cameraSharing: cameraSharing,
        screenSharing: screenSharing,
        initiated: initiated
    };
}
