import { EErrorEngineTypes } from "./enum/EErrorEngineTypes";
import { ILogger } from "./interface/ILogger";
import { TCallbackMessage } from "./type/TCallbackMessage";
export declare class Logger implements ILogger {
    debug: boolean;
    engines: Array<EErrorEngineTypes>;
    callbackMessage?: Function;
    constructor(engines: Array<EErrorEngineTypes>);
    error(message: TCallbackMessage): void;
    info(message: TCallbackMessage): void;
    warning(message: TCallbackMessage): void;
    log(message: TCallbackMessage): void;
    doLog(message: TCallbackMessage): void;
    doConsoleLog(message: TCallbackMessage): void;
    colorLog(message: TCallbackMessage, color: string): void;
    doNotifyView(message: TCallbackMessage): void;
    getCallbackMessage(): any;
    setCallbackMessage(value: Function): void;
}
