var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { ERuleTypes } from "../rules/enum/ERuleTypes";
import { v4 as uuidv4 } from "uuid";
import { EActionStatus } from "../action/enum/EActionStatus";
import { EMessageType } from "../logger/enum/EMessageType";
import { EOperationStatus } from "../operation/enum/EOperationStatus";
import { BaseManager } from "./base/BaseManager";
import { ChangeModuleConfigRules } from "../rules/ChangeModuleConfigRules";
import { ChangeModuleConfigOperation } from "../operation/ChangeModuleConfigOperation";
var parseError = require('parse-error');
var ChangeModuleConfigManager = /** @class */ (function (_super) {
    __extends(ChangeModuleConfigManager, _super);
    function ChangeModuleConfigManager(action, context) {
        return _super.call(this, action, context) || this;
    }
    /*@overwrite*/
    ChangeModuleConfigManager.prototype.performAction = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                        var params, validationRules, changeModuleConfigOperation, errors, error_1, errors;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    params = Object.assign(this.getAction().getParams());
                                    validationRules = new ChangeModuleConfigRules(params);
                                    validationRules.validate([ERuleTypes.IS_VALID_CONFIG_PARAMS], this.context);
                                    if (!validationRules.passes) return [3 /*break*/, 5];
                                    _a.label = 1;
                                case 1:
                                    _a.trys.push([1, 3, , 4]);
                                    changeModuleConfigOperation = new ChangeModuleConfigOperation(this.context);
                                    return [4 /*yield*/, changeModuleConfigOperation.handler(params)];
                                case 2:
                                    _a.sent();
                                    if (changeModuleConfigOperation.status == EOperationStatus.PERFORMED) {
                                        this.action.status = EActionStatus.PERFORMED;
                                        this.logger.log({
                                            id: uuidv4(),
                                            title: this.action.type,
                                            body: "Action " + this.action.type + " performaced",
                                            action: this.action,
                                            errors: validationRules.errors,
                                            type: EMessageType.INFO
                                        });
                                    }
                                    else {
                                        errors = [];
                                        if (changeModuleConfigOperation.errors)
                                            errors = __spreadArray(__spreadArray([], errors, true), changeModuleConfigOperation.errors, true);
                                        this.action.status = EActionStatus.FAILED;
                                        this.logger.log({
                                            id: uuidv4(),
                                            title: this.action.type,
                                            body: "Something operations not performaced in action " + this.action.type,
                                            action: this.action,
                                            errors: errors,
                                            type: EMessageType.ERROR
                                        });
                                    }
                                    return [3 /*break*/, 4];
                                case 3:
                                    error_1 = _a.sent();
                                    errors = parseError(error_1);
                                    this.action.status = EActionStatus.FAILED;
                                    this.logger.log({
                                        id: uuidv4(),
                                        title: this.action.type,
                                        body: "Something operations not performaced in action " + this.action.type,
                                        action: this.action,
                                        errors: errors,
                                        type: EMessageType.ERROR
                                    });
                                    return [3 /*break*/, 4];
                                case 4: return [3 /*break*/, 6];
                                case 5:
                                    this.action.status = EActionStatus.FAILED;
                                    this.logger.log({
                                        id: uuidv4(),
                                        title: this.action.type,
                                        body: "Action " + this.action.type + " not performaced",
                                        action: this.action,
                                        errors: validationRules.errors,
                                        type: EMessageType.ERROR
                                    });
                                    _a.label = 6;
                                case 6:
                                    resolve(this.action.status);
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
            });
        });
    };
    return ChangeModuleConfigManager;
}(BaseManager));
export { ChangeModuleConfigManager };
