var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { ShareScreenAction } from "../action/ShareScreenAction";
import { CustomError } from "../exception/CustomError";
import { ErrorType } from "../exception/enum/ErrorType";
import { setAction } from "../store/slices/action";
import { BaseOperation } from "./base/BaseOperation";
import { EOperationStatus } from "./enum/EOperationStatus";
import { EOperationType } from "./enum/EOperationType";
var PublishTracksOperation = /** @class */ (function (_super) {
    __extends(PublishTracksOperation, _super);
    function PublishTracksOperation(context) {
        var _this = _super.call(this, context) || this;
        _this.type = EOperationType.PUBLISH_TRACKS;
        return _this;
    }
    /*@overwrite*/
    PublishTracksOperation.prototype.handler = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                        var tracks, regionChangeActionParams, audioTrack, microphones, microphone, speakers, speaker, cameraTrack, cameras, camera, screenTrack, client_1, error_1;
                        var _this = this;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    _a.trys.push([0, 19, , 20]);
                                    this.context.getDeterminants().setUpdating(true);
                                    tracks = [];
                                    regionChangeActionParams = Object.assign(params ? params : {});
                                    if (regionChangeActionParams.keepTracks == false) {
                                        this.context.getDeterminants().setHasCamera(false);
                                        this.context.getDeterminants().setHasScreen(false);
                                    }
                                    if (!this.context.getDeterminants().getHasAudio()) return [3 /*break*/, 7];
                                    return [4 /*yield*/, this.context.getResources().getAudioTrack()];
                                case 1:
                                    audioTrack = _a.sent();
                                    if (!(audioTrack == undefined || audioTrack == null)) return [3 /*break*/, 5];
                                    return [4 /*yield*/, this.context.getResources().getMicrophones()];
                                case 2:
                                    microphones = _a.sent();
                                    microphone = Object.assign(this.context.getDeterminants().getMicrophoneSelected() ? this.context.getDeterminants().getMicrophoneSelected() : microphones && microphones.length > 0 ? microphones[0] : {});
                                    this.context.getDeterminants().setMicrophoneSelected(microphone);
                                    return [4 /*yield*/, this.context.getResources().getSpeakers()];
                                case 3:
                                    speakers = _a.sent();
                                    speaker = Object.assign(this.context.getDeterminants().getPlayBackSelected() ? this.context.getDeterminants().getPlayBackSelected() : speakers && speakers.length > 0 ? speakers[0] : {});
                                    this.context.getDeterminants().setPlayBackSelected(speaker);
                                    return [4 /*yield*/, this.context.getResources().createAudioTrack(microphone)];
                                case 4:
                                    audioTrack = _a.sent();
                                    _a.label = 5;
                                case 5: return [4 /*yield*/, audioTrack.setEnabled(true)];
                                case 6:
                                    _a.sent();
                                    tracks.push(audioTrack);
                                    _a.label = 7;
                                case 7:
                                    if (!this.context.getDeterminants().getHasCamera()) return [3 /*break*/, 13];
                                    return [4 /*yield*/, this.context.getResources().getVideoTrack()];
                                case 8:
                                    cameraTrack = _a.sent();
                                    if (!(cameraTrack == undefined || cameraTrack == null)) return [3 /*break*/, 11];
                                    return [4 /*yield*/, this.context.getResources().getCameras()];
                                case 9:
                                    cameras = _a.sent();
                                    camera = Object.assign(this.context.getDeterminants().getCameraSelected() ? this.context.getDeterminants().getCameraSelected() : cameras && cameras.length > 0 ? cameras[0] : {});
                                    this.context.getDeterminants().setCameraSelected(camera);
                                    return [4 /*yield*/, this.context.getResources().createVideoTrack(camera)];
                                case 10:
                                    cameraTrack = _a.sent();
                                    _a.label = 11;
                                case 11: return [4 /*yield*/, cameraTrack.setEnabled(true)];
                                case 12:
                                    _a.sent();
                                    tracks.push(cameraTrack);
                                    _a.label = 13;
                                case 13:
                                    if (!this.context.getDeterminants().getHasScreen()) return [3 /*break*/, 15];
                                    return [4 /*yield*/, this.context.getResources().createScreenTrack()];
                                case 14:
                                    screenTrack = _a.sent();
                                    screenTrack.on("track-ended", function () { return __awaiter(_this, void 0, void 0, function () {
                                        var params_1, action;
                                        return __generator(this, function (_a) {
                                            switch (_a.label) {
                                                case 0: return [4 /*yield*/, client_1.unpublish(this.context.getResources().getScreeanTrack())];
                                                case 1:
                                                    _a.sent();
                                                    return [4 /*yield*/, this.context.getDeterminants().setHasScreen(false)];
                                                case 2:
                                                    _a.sent();
                                                    if (this.context.getDeterminants().getActionDispatch()) {
                                                        params_1 = { active: false };
                                                        action = new ShareScreenAction(params_1);
                                                        this.context.getDeterminants().getActionDispatch()(setAction({ action: action }));
                                                    }
                                                    return [2 /*return*/];
                                            }
                                        });
                                    }); });
                                    tracks.push(screenTrack);
                                    _a.label = 15;
                                case 15:
                                    client_1 = this.context.getResources().getClient();
                                    if (!(tracks.length > 0)) return [3 /*break*/, 17];
                                    return [4 /*yield*/, client_1.publish(tracks)];
                                case 16:
                                    _a.sent();
                                    this.status = EOperationStatus.PERFORMED;
                                    return [3 /*break*/, 18];
                                case 17:
                                    this.addError(new CustomError(ErrorType.BUSINESS, "Cannot publish track", "Cannot publish track, because no stream tracks were found"));
                                    this.status = EOperationStatus.FAILED;
                                    _a.label = 18;
                                case 18: return [3 /*break*/, 20];
                                case 19:
                                    error_1 = _a.sent();
                                    this.addError(error_1);
                                    this.status = EOperationStatus.FAILED;
                                    return [3 /*break*/, 20];
                                case 20:
                                    resolve(this.status);
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
            });
        });
    };
    return PublishTracksOperation;
}(BaseOperation));
export { PublishTracksOperation };
