import { ActionParams } from "../../action/type/ActionParams";
import { Context } from "../../context/Context";
import { CustomError } from "../../exception/CustomError";
import { EOperationStatus } from "../enum/EOperationStatus";
import { EOperationType } from "../enum/EOperationType";
import { IOperation } from "../interface/IOperation";
export declare class BaseOperation implements IOperation {
    type: EOperationType;
    status: EOperationStatus;
    datetime: Date;
    context: Context;
    errors: Array<CustomError>;
    constructor(context: Context);
    addError(error: any): void;
    setContext(context: Context): void;
    getContext(): Context;
    handler(params?: ActionParams): Promise<string>;
}
