var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/*
* use https://www.npmjs.com/package/validatorjs
*/
import { ERuleTypes } from "./enum/ERuleTypes";
import { BaseRule } from "./base/BaseRule";
import { CommonRules } from "./CommonRules";
var ActiveProxyRules = /** @class */ (function (_super) {
    __extends(ActiveProxyRules, _super);
    function ActiveProxyRules(params) {
        return _super.call(this, params) || this;
    }
    /*@overwrite*/
    ActiveProxyRules.prototype.validate = function (rules, context) {
        var _this = this;
        var passes = [];
        rules.forEach(function (rule) {
            switch (rule) {
                case ERuleTypes.PROXY_VALID_TYPE:
                    passes.push(_this.validProxyType(_this.params));
                    break;
                case ERuleTypes.IS_CLIENT_INIT:
                    passes.push(new CommonRules(_this.params).isClientInit(context, _this));
                    break;
            }
        });
        if (passes.every(function (pass) { return pass == true; })) {
            this.passes = true;
            return true;
        }
        else {
            this.fails = true;
            return false;
        }
    };
    ActiveProxyRules.prototype.validProxyType = function (params) {
        var paramsObj = Object.assign(params);
        var data = {
            proxy_type: paramsObj.type,
        };
        var rules = {
            proxy_type: 'numeric|in:3,5'
        };
        var messages = {
            "number.proxy_type": 'Invalid proxy type',
            "in.proxy_type": 'Invalid proxy type'
        };
        return this.evaluate(data, rules, messages);
    };
    return ActiveProxyRules;
}(BaseRule));
export { ActiveProxyRules };
