var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/*
* use https://www.npmjs.com/package/validatorjs
*/
import { ERuleTypes } from "./enum/ERuleTypes";
import { BaseRule } from "./base/BaseRule";
var ChangeDeviceRules = /** @class */ (function (_super) {
    __extends(ChangeDeviceRules, _super);
    function ChangeDeviceRules(params) {
        return _super.call(this, params) || this;
    }
    /*@overwrite*/
    ChangeDeviceRules.prototype.validate = function (rules, context) {
        var _this = this;
        var passes = [];
        rules.forEach(function (rule) {
            switch (rule) {
                case ERuleTypes.IS_VALID_DEVICE:
                    passes.push(_this.isCorrectDevice(_this.params));
                    break;
            }
        });
        if (passes.every(function (pass) { return pass == true; })) {
            this.passes = true;
            return true;
        }
        else {
            this.fails = true;
            return false;
        }
    };
    ChangeDeviceRules.prototype.isCorrectDevice = function (params) {
        var paramsObj = Object.assign(params);
        var device = paramsObj.device ? paramsObj.device : null;
        var data = {
            device_type: paramsObj.type,
            device_id: device ? device.deviceId : "",
            device_name: device ? device.label : "",
        };
        var rules = {
            device_type: 'string|in:microphone,camera,playback',
            device_id: 'required',
            device_name: 'required'
        };
        var messages = {
            "string.device_type": 'Invalid device type',
            "in.device_type": 'Invalid device type',
            "required.device_id": 'Device identifier is required',
            "required.device_name": 'Device name is required',
        };
        return this.evaluate(data, rules, messages);
    };
    return ChangeDeviceRules;
}(BaseRule));
export { ChangeDeviceRules };
