var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/*
* use https://www.npmjs.com/package/validatorjs
*/
import { ERuleTypes } from "./enum/ERuleTypes";
import { BaseRule } from "./base/BaseRule";
import { CommonRules } from "./CommonRules";
var ChangeModuleConfigRules = /** @class */ (function (_super) {
    __extends(ChangeModuleConfigRules, _super);
    function ChangeModuleConfigRules(params) {
        return _super.call(this, params) || this;
    }
    /*@overwrite*/
    ChangeModuleConfigRules.prototype.validate = function (rules, context) {
        var _this = this;
        var passes = [];
        rules.forEach(function (rule) {
            switch (rule) {
                case ERuleTypes.IS_NOT_INITIATED:
                    passes.push(new CommonRules(_this.params).isNotInited(context, _this));
                    break;
                case ERuleTypes.IS_VALID_CONFIG_PARAMS:
                    var params = Object.assign(_this.params);
                    passes.push(_this.isValidConfigParams(params));
                    break;
            }
        });
        return this.passesOrFails(passes);
    };
    ChangeModuleConfigRules.prototype.isValidConfigParams = function (params) {
        var rules = {
            'uid': "sometimes|string",
            'app_id': "sometimes|string|alpha_num",
            'client_config': "sometimes",
            'user': "required",
        };
        var messages = {
            "string.uid": 'The user identifier must be a string',
            "string.app_id": 'The aplication identifier must be a string',
            "alpha_num.app_id": 'The aplication identifier must be a string alpha numeric',
            "user": 'The user information is required',
        };
        return this.evaluate(params, rules, messages);
    };
    return ChangeModuleConfigRules;
}(BaseRule));
export { ChangeModuleConfigRules };
