var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/*
* use https://www.npmjs.com/package/validatorjs
*/
import { ERuleTypes } from "./enum/ERuleTypes";
import { BaseRule } from "./base/BaseRule";
import { CommonRules } from "./CommonRules";
import { RoleUserEnum } from "../context/enum/RoleUserEnum";
var ChangeRoleRules = /** @class */ (function (_super) {
    __extends(ChangeRoleRules, _super);
    function ChangeRoleRules(params) {
        return _super.call(this, params) || this;
    }
    /*@overwrite*/
    ChangeRoleRules.prototype.validate = function (rules, context) {
        var _this = this;
        var passes = [];
        rules.forEach(function (rule) {
            switch (rule) {
                case ERuleTypes.IS_VALID_ROLE:
                    passes.push(_this.isValidRole(_this.params));
                    break;
                case ERuleTypes.IS_DISCONNECTED:
                    passes.push(new CommonRules(_this.params).isDisconnected(context, _this));
                    break;
            }
        });
        if (passes.every(function (pass) { return pass == true; })) {
            this.passes = true;
            return true;
        }
        else {
            this.fails = true;
            return false;
        }
    };
    ChangeRoleRules.prototype.isValidRole = function (params) {
        var paramsObj = Object.assign(params);
        var data = {
            role_type: paramsObj.role,
        };
        var rules = {
            role_type: 'string|in:' + RoleUserEnum.Audience + "," + RoleUserEnum.Host
        };
        var messages = {
            "number.role_type": 'Invalid role type',
            "in.role_type": 'Invalid role type'
        };
        return this.evaluate(data, rules, messages);
    };
    return ChangeRoleRules;
}(BaseRule));
export { ChangeRoleRules };
