var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { BaseRule } from "./base/BaseRule";
import { ConnectionStatesEnum } from "../context/enum/ConnectionStates";
var CommonRules = /** @class */ (function (_super) {
    __extends(CommonRules, _super);
    function CommonRules(params) {
        return _super.call(this, params) || this;
    }
    CommonRules.prototype.isClientInit = function (context, instance) {
        var data = {
            client: context.getResources().getClient(),
        };
        var rules = {
            client: 'required'
        };
        var messages = {
            "required.client": 'The client must be initiated'
        };
        return instance.evaluate(data, rules, messages);
    };
    CommonRules.prototype.isHost = function (context, instance) {
        var data = {
            role: context.getDeterminants().getRole(),
        };
        var rules = {
            role: 'required|in:host'
        };
        var messages = {
            "required.role": 'The role is required',
            "in.role": 'The role must be host'
        };
        return instance.evaluate(data, rules, messages);
    };
    CommonRules.prototype.isInited = function (context, instance) {
        var data = {
            init: context.getDeterminants().getInit(),
        };
        var rules = {
            init: 'boolean|in:true'
        };
        var messages = {
            "in.init": 'Is not initiated'
        };
        return instance.evaluate(data, rules, messages);
    };
    CommonRules.prototype.isNotInited = function (context, instance) {
        var data = {
            init: context.getDeterminants().getInit(),
        };
        var rules = {
            init: 'boolean|in:false'
        };
        var messages = {
            "in.init": 'Is already initiated'
        };
        return instance.evaluate(data, rules, messages);
    };
    CommonRules.prototype.isConnected = function (context, instance) {
        var data = {
            connection_state: context.getDeterminants().getConnectionState().curState,
        };
        var rules = {
            connection_state: 'in:' + ConnectionStatesEnum.CONNECTED
        };
        var messages = {
            "in.connection_state": 'Connection state must be ' + ConnectionStatesEnum.CONNECTED
        };
        return instance.evaluate(data, rules, messages);
    };
    CommonRules.prototype.isDisconnected = function (context, instance) {
        var data = {
            connection_state: context.getDeterminants().getConnectionState().curState,
        };
        var rules = {
            connection_state: 'in:' + ConnectionStatesEnum.DISCONNECTED
        };
        var messages = {
            "in.connection_state": 'Connection state must be ' + ConnectionStatesEnum.DISCONNECTED
        };
        return instance.evaluate(data, rules, messages);
    };
    return CommonRules;
}(BaseRule));
export { CommonRules };
