var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { ERuleTypes } from "./enum/ERuleTypes";
import { BaseRule } from "./base/BaseRule";
import { CommonRules } from "./CommonRules";
var InitRules = /** @class */ (function (_super) {
    __extends(InitRules, _super);
    function InitRules(params) {
        return _super.call(this, params) || this;
    }
    /*@overwrite*/
    InitRules.prototype.validate = function (rules, context) {
        var _this = this;
        var passes = [];
        rules.forEach(function (rule) {
            switch (rule) {
                case ERuleTypes.IS_INITIATED:
                    passes.push(new CommonRules(_this.params).isInited(context, _this));
                    break;
                case ERuleTypes.IS_NOT_INITIATED:
                    passes.push(new CommonRules(_this.params).isNotInited(context, _this));
                    break;
                case ERuleTypes.INIT_PARAM_IS_TRUE:
                    passes.push(_this.initParamIsTrue(_this.params));
                    break;
            }
        });
        if (passes.every(function (pass) { return pass == true; })) {
            this.passes = true;
            return true;
        }
        else {
            this.fails = true;
            return false;
        }
    };
    InitRules.prototype.initParamIsTrue = function (params) {
        var paramsObj = Object.assign(params);
        var data = {
            init_param: paramsObj.init
        };
        var rules = {
            init_param: 'boolean|accepted'
        };
        var messages = {
            "accepted.init_param": 'Init param must be true to init agora'
        };
        return this.evaluate(data, rules, messages);
    };
    return InitRules;
}(BaseRule));
export { InitRules };
