var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/*
* use https://www.npmjs.com/package/validatorjs
*/
import { ERuleTypes } from "./enum/ERuleTypes";
import { BaseRule } from "./base/BaseRule";
import { CommonRules } from "./CommonRules";
var RegionChangeRules = /** @class */ (function (_super) {
    __extends(RegionChangeRules, _super);
    function RegionChangeRules(params) {
        return _super.call(this, params) || this;
    }
    /*@overwrite*/
    RegionChangeRules.prototype.validate = function (rules, context) {
        var _this = this;
        var passes = [];
        rules.forEach(function (rule) {
            switch (rule) {
                case ERuleTypes.IS_CLIENT_INIT:
                    passes.push(new CommonRules(_this.params).isClientInit(context, _this));
                    break;
                case ERuleTypes.IS_INITIATED:
                    passes.push(new CommonRules(_this.params).isInited(context, _this));
                    break;
                case ERuleTypes.IS_HOST:
                    passes.push(new CommonRules(_this.params).isHost(context, _this));
                    break;
                case ERuleTypes.IS_CONNECTED:
                    passes.push(new CommonRules(_this.params).isConnected(context, _this));
                    break;
                case ERuleTypes.IS_VALID_CHANNEL:
                    passes.push(_this.channelParamValidate(_this.params));
                    break;
            }
        });
        return this.passesOrFails(passes);
    };
    RegionChangeRules.prototype.channelParamValidate = function (params) {
        var paramsObj = Object.assign(params);
        var data = {
            channel: paramsObj.channel
        };
        var rules = {
            channel: 'required|string|max:64|not_in:undefined'
        };
        var messages = {
            "required.channel": 'Channel param is required',
            "string.channel": 'Channel param must be string',
            "max.channel": 'Channel param must be have max 32 characters',
            "not_in.channel": 'Channel param is required',
        };
        return this.evaluate(data, rules, messages);
    };
    return RegionChangeRules;
}(BaseRule));
export { RegionChangeRules };
