var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/*
* use https://www.npmjs.com/package/validatorjs
*/
import { ERuleTypes } from "./enum/ERuleTypes";
import { BaseRule } from "./base/BaseRule";
var ToggleVoiceRules = /** @class */ (function (_super) {
    __extends(ToggleVoiceRules, _super);
    function ToggleVoiceRules(params) {
        return _super.call(this, params) || this;
    }
    /*@overwrite*/
    ToggleVoiceRules.prototype.validate = function (rules, context) {
        var _this = this;
        var passes = [];
        rules.forEach(function (rule) {
            switch (rule) {
                case ERuleTypes.IS_AUDIO_TRACK_ENABLE:
                    passes.push(_this.isAudioTrackEnable(context));
                    break;
                case ERuleTypes.HAS_AUDIO_TRACK:
                    passes.push(_this.hasAudioTrack(context));
                    break;
            }
        });
        if (passes.every(function (pass) { return pass == true; })) {
            this.passes = true;
            return true;
        }
        else {
            this.fails = true;
            return false;
        }
    };
    ToggleVoiceRules.prototype.isAudioTrackEnable = function (context) {
        var track = context.getResources().getAudioTrack();
        var enable = false;
        if (track) {
            enable = track.enabled;
        }
        else {
            enable = false;
        }
        var data = {
            track: enable + "",
        };
        var rules = {
            track: 'in:true'
        };
        var messages = {
            "in.track": 'Audio must be enable',
        };
        return this.evaluate(data, rules, messages);
    };
    ToggleVoiceRules.prototype.hasAudioTrack = function (context) {
        var track = context.getResources().getAudioTrack();
        var exist = false;
        if (track) {
            exist = true;
        }
        var data = {
            track: exist + "",
        };
        var rules = {
            track: 'in:true'
        };
        var messages = {
            "in.track": 'Audio not available',
        };
        return this.evaluate(data, rules, messages);
    };
    return ToggleVoiceRules;
}(BaseRule));
export { ToggleVoiceRules };
