import { ActionParams } from "../../action/type/ActionParams";
import { Context } from "../../context/Context";
import { CustomError } from "../../exception/CustomError";
import { IRule } from "../interface/IRule";
import Validator from 'validatorjs';
export declare class BaseRule implements IRule {
    validator: Validator.Validator<any>;
    errors: Array<CustomError>;
    passes: boolean;
    fails: boolean;
    params: ActionParams;
    constructor(params: ActionParams);
    addError(error: any): void;
    getErrors(): Array<any>;
    evaluate(data: any, rules: any, messages: any): boolean;
    reset(): void;
    passesOrFails(passes: Array<boolean>): boolean;
    validate(rules: Array<string>, context: Context): boolean;
}
