import { IWorker } from "../interface/IWorker";
import { EWorkerType } from "../enum/EWorkerType";
import { EWorkerStatus } from "../enum/EWorkerStatus";
import { Context } from "../../context/Context";
import { IAction } from "../../action/interface/IAction";
import { WSTransport } from "../../transport/WSTransport";
import { EActionStatus } from "../../action/enum/EActionStatus";
export declare class BaseWorker implements IWorker {
    actions: Array<IAction>;
    time: number;
    type: EWorkerType;
    status: EWorkerStatus;
    datetime: number;
    context: Context;
    maxIntents: number;
    working: boolean;
    deleteActionCallback: Function;
    reintentActionCallback: Function;
    tranport: WSTransport;
    isWorking(): boolean;
    getContext(): Context;
    setContext(value: Context): void;
    getActions(): Array<IAction>;
    setActions(value: Array<IAction>): void;
    getDeleteActionCallback(): Function;
    setDeleteActionCallback(value: Function): void;
    getReintentActionCallback(): Function;
    setReintentActionCallback(value: Function): void;
    getTranport(): WSTransport;
    setTranport(value: WSTransport): void;
    performeAction(action: IAction): Promise<EActionStatus>;
    doConfirmToTransport(action: IAction, status: EActionStatus): void;
    inflateMessageConfirm(action: IAction, status: EActionStatus): ({
        payloadType: string;
        payload: {
            IsMuted: string;
            userId: string;
            action?: undefined;
            presenting?: undefined;
            screen_uid?: undefined;
            sharing?: undefined;
            UserId?: undefined;
            EventId?: undefined;
            Region?: undefined;
            RegionId?: undefined;
            AgoraRole?: undefined;
            EnteredRegion?: undefined;
            AgoraAccount?: undefined;
            Session?: undefined;
        };
    } | {
        payloadType: string;
        payload: {
            userId: string;
            action: string;
            IsMuted?: undefined;
            presenting?: undefined;
            screen_uid?: undefined;
            sharing?: undefined;
            UserId?: undefined;
            EventId?: undefined;
            Region?: undefined;
            RegionId?: undefined;
            AgoraRole?: undefined;
            EnteredRegion?: undefined;
            AgoraAccount?: undefined;
            Session?: undefined;
        };
    } | {
        payloadType: string;
        payload: {
            presenting: string;
            IsMuted?: undefined;
            userId?: undefined;
            action?: undefined;
            screen_uid?: undefined;
            sharing?: undefined;
            UserId?: undefined;
            EventId?: undefined;
            Region?: undefined;
            RegionId?: undefined;
            AgoraRole?: undefined;
            EnteredRegion?: undefined;
            AgoraAccount?: undefined;
            Session?: undefined;
        };
    } | {
        payloadType: string;
        payload: {
            screen_uid: string | number;
            sharing: string;
            IsMuted?: undefined;
            userId?: undefined;
            action?: undefined;
            presenting?: undefined;
            UserId?: undefined;
            EventId?: undefined;
            Region?: undefined;
            RegionId?: undefined;
            AgoraRole?: undefined;
            EnteredRegion?: undefined;
            AgoraAccount?: undefined;
            Session?: undefined;
        };
    } | {
        payloadType: string;
        payload: {
            UserId: string;
            EventId: string;
            Region: string;
            RegionId: string;
            AgoraRole: string;
            EnteredRegion: string;
            AgoraAccount: any;
            Session: string;
            IsMuted?: undefined;
            userId?: undefined;
            action?: undefined;
            presenting?: undefined;
            screen_uid?: undefined;
            sharing?: undefined;
        };
    })[];
    run(): void;
    handlerAction(action: IAction): Promise<void>;
}
