var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { InitActionManager } from "../../manager/InitManager";
import { EActionType } from "../../action/enum/EActionType";
import { EActionStatus } from "../../action/enum/EActionStatus";
import { RegionChangeActionManager } from "../../manager/RegionChangeManager";
import { ActiveProxyActionManager } from "../../manager/ActiveProxyManager";
import { DisconnectManager } from "../../manager/DisconnectManager";
import { ToggleVoiceManager } from "../../manager/ToggleVoiceManager";
import { ChangeDeviceManager } from "../../manager/ChangeDeviceManager";
import { SubscribeManager } from "../../manager/SubscribeManager";
import { UnsubscribeManager } from "../../manager/UnsubscribeManager";
import { ShareCameraManager } from "../../manager/ShareCameraManager";
import { ShareScreenManager } from "../../manager/ShareScreenManager";
import { ChangeRoleManager } from "../../manager/ChangeRoleManager";
import { ChangeModuleConfigManager } from "../../manager/ChangeModuleConfigManager";
var BaseWorker = /** @class */ (function () {
    function BaseWorker() {
        this.time = 100;
        this.maxIntents = 5;
        this.working = false;
    }
    BaseWorker.prototype.isWorking = function () {
        return this.working;
    };
    BaseWorker.prototype.getContext = function () {
        return this.context;
    };
    BaseWorker.prototype.setContext = function (value) {
        this.context = value;
    };
    BaseWorker.prototype.getActions = function () {
        return this.actions;
    };
    BaseWorker.prototype.setActions = function (value) {
        this.actions = value;
    };
    BaseWorker.prototype.getDeleteActionCallback = function () {
        return this.deleteActionCallback;
    };
    BaseWorker.prototype.setDeleteActionCallback = function (value) {
        this.deleteActionCallback = value;
    };
    BaseWorker.prototype.getReintentActionCallback = function () {
        return this.reintentActionCallback;
    };
    BaseWorker.prototype.setReintentActionCallback = function (value) {
        this.reintentActionCallback = value;
    };
    BaseWorker.prototype.getTranport = function () {
        return this.tranport;
    };
    BaseWorker.prototype.setTranport = function (value) {
        this.tranport = value;
    };
    BaseWorker.prototype.performeAction = function (action) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
                        var manager, statusAction, _a;
                        return __generator(this, function (_b) {
                            switch (_b.label) {
                                case 0:
                                    statusAction = action.status;
                                    _a = action.type;
                                    switch (_a) {
                                        case EActionType.INIT_AGORA: return [3 /*break*/, 1];
                                        case EActionType.REGION_CHANGE: return [3 /*break*/, 3];
                                        case EActionType.ACTIVE_PROXY: return [3 /*break*/, 5];
                                        case EActionType.DISCONNECT: return [3 /*break*/, 7];
                                        case EActionType.TOGGLE_VOICE: return [3 /*break*/, 9];
                                        case EActionType.CHANGE_DEVICE: return [3 /*break*/, 11];
                                        case EActionType.SUBSCRIBE: return [3 /*break*/, 13];
                                        case EActionType.UNSUBSCRIBE: return [3 /*break*/, 15];
                                        case EActionType.SHARE_CAMERA: return [3 /*break*/, 17];
                                        case EActionType.SHARE_SCREEN: return [3 /*break*/, 19];
                                        case EActionType.CHANGE_ROLE: return [3 /*break*/, 21];
                                        case EActionType.CHANGE_MODULE_CONFIG: return [3 /*break*/, 23];
                                    }
                                    return [3 /*break*/, 25];
                                case 1:
                                    manager = new InitActionManager(action, this.context);
                                    return [4 /*yield*/, manager.performAction()];
                                case 2:
                                    statusAction = _b.sent();
                                    return [3 /*break*/, 26];
                                case 3:
                                    manager = new RegionChangeActionManager(action, this.context);
                                    return [4 /*yield*/, manager.performAction()];
                                case 4:
                                    statusAction = _b.sent();
                                    return [3 /*break*/, 26];
                                case 5:
                                    manager = new ActiveProxyActionManager(action, this.context);
                                    return [4 /*yield*/, manager.performAction()];
                                case 6:
                                    statusAction = _b.sent();
                                    return [3 /*break*/, 26];
                                case 7:
                                    manager = new DisconnectManager(action, this.context);
                                    return [4 /*yield*/, manager.performAction()];
                                case 8:
                                    statusAction = _b.sent();
                                    return [3 /*break*/, 26];
                                case 9:
                                    manager = new ToggleVoiceManager(action, this.context);
                                    return [4 /*yield*/, manager.performAction()];
                                case 10:
                                    statusAction = _b.sent();
                                    return [3 /*break*/, 26];
                                case 11:
                                    manager = new ChangeDeviceManager(action, this.context);
                                    return [4 /*yield*/, manager.performAction()];
                                case 12:
                                    statusAction = _b.sent();
                                    return [3 /*break*/, 26];
                                case 13:
                                    manager = new SubscribeManager(action, this.context);
                                    return [4 /*yield*/, manager.performAction()];
                                case 14:
                                    statusAction = _b.sent();
                                    return [3 /*break*/, 26];
                                case 15:
                                    manager = new UnsubscribeManager(action, this.context);
                                    return [4 /*yield*/, manager.performAction()];
                                case 16:
                                    statusAction = _b.sent();
                                    return [3 /*break*/, 26];
                                case 17:
                                    manager = new ShareCameraManager(action, this.context);
                                    return [4 /*yield*/, manager.performAction()];
                                case 18:
                                    statusAction = _b.sent();
                                    return [3 /*break*/, 26];
                                case 19:
                                    manager = new ShareScreenManager(action, this.context);
                                    return [4 /*yield*/, manager.performAction()];
                                case 20:
                                    statusAction = _b.sent();
                                    return [3 /*break*/, 26];
                                case 21:
                                    manager = new ChangeRoleManager(action, this.context);
                                    return [4 /*yield*/, manager.performAction()];
                                case 22:
                                    statusAction = _b.sent();
                                    return [3 /*break*/, 26];
                                case 23:
                                    manager = new ChangeModuleConfigManager(action, this.context);
                                    return [4 /*yield*/, manager.performAction()];
                                case 24:
                                    statusAction = _b.sent();
                                    return [3 /*break*/, 26];
                                case 25: return [3 /*break*/, 26];
                                case 26:
                                    resolve(statusAction);
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
            });
        });
    };
    BaseWorker.prototype.doConfirmToTransport = function (action, status) {
        var _this = this;
        try {
            if (this.context.getDeterminants() && this.context.getDeterminants().getTranport() && action.requiredConfirm) {
                var messages = this.inflateMessageConfirm(action, status);
                messages.forEach(function (message) {
                    _this.context.getDeterminants().getTranport().getInstanceEmiterCallback().send(JSON.stringify(message));
                });
            }
        }
        catch (error) { }
    };
    BaseWorker.prototype.inflateMessageConfirm = function (action, status) {
        var message = [];
        var channel;
        try {
            switch (action.type) {
                case EActionType.TOGGLE_VOICE:
                    var toggleVoiceActionParams = Object.assign(action.params);
                    switch (status) {
                        case EActionStatus.PERFORMED:
                            message.push({
                                "payloadType": "muteAck",
                                "payload": {
                                    "IsMuted": (toggleVoiceActionParams.action) + "",
                                    "userId": this.context.getDeterminants().getUserInformation().userId + ""
                                }
                            });
                            break;
                        case EActionStatus.FAILED:
                            message.push({
                                "payloadType": "muteAck",
                                "payload": {
                                    "IsMuted": (!toggleVoiceActionParams.action) + "",
                                    "userId": this.context.getDeterminants().getUserInformation().userId + ""
                                }
                            });
                            break;
                        default:
                            break;
                    }
                    break;
                case EActionType.SHARE_CAMERA:
                    var shareCameraActionParams = Object.assign(action.params);
                    switch (status) {
                        case EActionStatus.PERFORMED:
                            channel = this.context.getDeterminants().getChannel() != undefined ? this.context.getDeterminants().getChannel() + "" : "";
                            if (channel.indexOf("private-user-" + this.context.getDeterminants().getUserInformation().userId) < 0) {
                                message.push({
                                    "payloadType": "frameUIAck",
                                    "payload": {
                                        "userId": this.context.getDeterminants().getUserInformation().userId + "",
                                        "action": shareCameraActionParams.active ? "openWebcam" : "closeWebcam"
                                    }
                                });
                                message.push({
                                    "payloadType": "frameCameraChange",
                                    "payload": { "presenting": shareCameraActionParams.active + "" }
                                });
                            }
                            break;
                        case EActionStatus.FAILED:
                            channel = this.context.getDeterminants().getChannel() != undefined ? this.context.getDeterminants().getChannel() + "" : "";
                            if (channel.indexOf("private-user-" + this.context.getDeterminants().getUserInformation().userId) < 0) {
                                message.push({
                                    "payloadType": "frameUIAck",
                                    "payload": {
                                        "userId": this.context.getDeterminants().getUserInformation().userId + "",
                                        "action": shareCameraActionParams.active ? "closeWebcam" : "openWebcam"
                                    }
                                });
                                message.push({
                                    "payloadType": "frameCameraChange",
                                    "payload": { "presenting": (!shareCameraActionParams.active) + "" }
                                });
                            }
                            break;
                        default:
                            break;
                    }
                    break;
                case EActionType.SHARE_SCREEN:
                    var shareScreenActionParams = Object.assign(action.params);
                    switch (status) {
                        case EActionStatus.PERFORMED:
                            message.push({
                                "payloadType": "frameUIAck",
                                "payload": {
                                    "userId": this.context.getDeterminants().getUserInformation().userId + "",
                                    "action": shareScreenActionParams.active ? "openShareScreen" : "closeShareScreen"
                                }
                            });
                            message.push({
                                "payloadType": "screenIndicator",
                                "payload": {
                                    "screen_uid": this.context.getDeterminants().getUid(),
                                    "sharing": shareScreenActionParams.active + ""
                                }
                            });
                            break;
                        case EActionStatus.FAILED:
                            message.push({
                                "payloadType": "frameUIAck",
                                "payload": {
                                    "userId": this.context.getDeterminants().getUserInformation().userId + "",
                                    "action": shareScreenActionParams.active ? "closeShareScreen" : "openShareScreen"
                                }
                            });
                            message.push({
                                "payloadType": "screenIndicator",
                                "payload": {
                                    "screen_uid": this.context.getDeterminants().getUid(),
                                    "sharing": (!shareScreenActionParams.active) + ""
                                }
                            });
                            break;
                        default:
                            break;
                    }
                    break;
                case EActionType.REGION_CHANGE:
                    var regionChangeActionParams = Object.assign(action.params);
                    switch (status) {
                        case EActionStatus.PERFORMED:
                            var client = this.context.getResources() && this.context.getResources().getClient() ? this.context.getResources().getClient() : null;
                            message.push({
                                "payloadType": "regionConfirm",
                                "payload": {
                                    "UserId": this.context.getDeterminants().getUserInformation().userId + "",
                                    "EventId": this.context.getDeterminants().getUserInformation().currentEventId + "",
                                    "Region": " ",
                                    "RegionId": "" + regionChangeActionParams.channel,
                                    "AgoraRole": "" + regionChangeActionParams.role,
                                    "EnteredRegion": "true",
                                    "AgoraAccount": client ? client._joinInfo.uid : '',
                                    "Session": " ",
                                }
                            });
                            if (regionChangeActionParams.channel.indexOf("private-user-" + this.context.getDeterminants().getUserInformation().userId) < 0
                                && regionChangeActionParams.keepTracks != false) {
                                if (this.context.getDeterminants().getHasCamera()) {
                                    message.push({
                                        "payloadType": "frameUIAck",
                                        "payload": {
                                            "userId": this.context.getDeterminants().getUserInformation().userId + "",
                                            "action": this.context.getDeterminants().getHasCamera() ? "openWebcam" : "closeWebcam"
                                        }
                                    });
                                    message.push({
                                        "payloadType": "frameCameraChange",
                                        "payload": { "presenting": this.context.getDeterminants().getHasCamera() + "" }
                                    });
                                }
                                if (this.context.getDeterminants().getHasScreen()) {
                                    message.push({
                                        "payloadType": "frameUIAck",
                                        "payload": {
                                            "userId": this.context.getDeterminants().getUserInformation().userId + "",
                                            "action": this.context.getDeterminants().getHasScreen() ? "openShareScreen" : "closeShareScreen"
                                        }
                                    });
                                    message.push({
                                        "payloadType": "screenIndicator",
                                        "payload": {
                                            "screen_uid": this.context.getDeterminants().getUid(),
                                            "sharing": this.context.getDeterminants().getHasScreen() + ""
                                        }
                                    });
                                }
                            }
                            break;
                        default:
                            break;
                    }
                    break;
                default:
                    break;
            }
        }
        catch (error) { }
        return message;
    };
    BaseWorker.prototype.run = function () { };
    BaseWorker.prototype.handlerAction = function (action) {
        return __awaiter(this, void 0, void 0, function () {
            var statusAction;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!action) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.performeAction(action)];
                    case 1:
                        statusAction = _a.sent();
                        if (action.status == EActionStatus.KEEPOUT) {
                            this.getDeleteActionCallback()(action.id + ":" + Date.now());
                        }
                        else if (statusAction == EActionStatus.PERFORMED) {
                            //EMIT SUCCESS CONFIRM
                            this.doConfirmToTransport(action, EActionStatus.PERFORMED);
                            this.getDeleteActionCallback()(action.id + ":" + Date.now());
                        }
                        else if (statusAction == EActionStatus.FAILED) {
                            if (action.requiredReintent == true && action.intent < this.maxIntents) {
                                this.getReintentActionCallback()(action.id + ":" + Date.now());
                            }
                            else {
                                //EMIT ERROR CONFIRM
                                this.doConfirmToTransport(action, EActionStatus.FAILED);
                                this.getDeleteActionCallback()(action.id + ":" + Date.now());
                            }
                        }
                        else {
                            //EMIT ERROR CONFIRM
                            this.doConfirmToTransport(action, EActionStatus.FAILED);
                            this.getDeleteActionCallback()(action.id + ":" + Date.now());
                        }
                        _a.label = 2;
                    case 2:
                        this.working = false;
                        return [2 /*return*/];
                }
            });
        });
    };
    return BaseWorker;
}());
export { BaseWorker };
