import {ActionsHook} from "./module/hooks/ActionsHook";

import {EActionPriorityTyp} from ""

import {Context as ContextClass} from "./module/context/Context";

/*Export Main Hook Module */
export const useAgoraActions = ActionsHook;

import { ConnectionStatesEnum, ConnectionStatesType } from "./module/context/enum/ConnectionStates";
import { CustomListernerLiveStreamingEnum, CustomListernerLiveStreamingType } from "./module/context/enum/CustomListernerLiveStreamingEnum";
import { DeviceTypeEnum, DeviceType } from "./module/context/enum/DeviceTypeEnum";
import { ListenerEnum, ListenerType} from "./module/context/enum/ListenerEnum";
import { LogLevelEnum, LogLevelType} from "./module/context/enum/LogLevelEnum";
import { MediaTypeEnum, MediaType} from "./module/context/enum/MediaTypeEnum";
import { RoleUserEnum , RoleUserType} from "./module/context/enum/RoleUserEnum";
import { LiveStreamProviderEnum, LiveStreamProviderType } from "./module/context/enum/LiveStreamProviderEnum";


/*Export Main Enums*/
/*Export Main Enums*/
export const EConnectionStates = ConnectionStatesEnum;
export type {ConnectionStatesType as TConnectionStates};

export const ECustomListernerLiveStreaming = CustomListernerLiveStreamingEnum;
export type {CustomListernerLiveStreamingType as TCustomListernerLiveStreaming};

export const EDeviceType = DeviceTypeEnum;
export type {DeviceType as TDevice};

export const EListener = ListenerEnum;
export type {ListenerType as TListener};


export const ELogLevel = LogLevelEnum;
export type {LogLevelType as TLogLevel};

export const EMedia = MediaTypeEnum;
export type {MediaType as TLoTMediaLevel};

export const ERoleUser = RoleUserEnum;
export type {RoleUserType as TRoleUser};

export const ELiveStreamProvider  = LiveStreamProviderEnum;
export type {LiveStreamProviderType as TLiveStreamProvider};

export const EActionPriority = EActionPriorityType;

import ContextEntity from "./module/store/slices/context";
import ActionEntity from "./module/store/slices/action";
import { EActionPriorityType } from "./module/action/enum/EActionPriorityType";


/*Export Redux Entities*/

export const ContextReduxSlice = ContextEntity;
export const ActionReduxSlice = ActionEntity;

/*Context*/
export const Context = ContextClass;