import { IAgoraRTCClient } from "agora-rtc-sdk-ng";
import { ListenerEnum } from "../enum/ListenerEnum";

export class Listeners {

    private _client!: IAgoraRTCClient;
    public _readyCallback: boolean = false;

    constructor(client: IAgoraRTCClient){
       this._client = client;
    }

    public isReadyCallbacks() : boolean {
        return this._readyCallback;
    }

    public setReadyCallbacks(ready:boolean) : void {
        this._readyCallback = ready;
    }

    public userJoined(callback: Function) {

        this._client.on(ListenerEnum.UserJoined, callback);

    }

    public userLeft(callback: Function) {

        this._client.on(ListenerEnum.UserLeft, callback);

    }

    public userPublished(callback: Function) {

        this._client.on(ListenerEnum.UserPublished, callback);

    }

    public userUnpublished(callback: Function) {

        this._client.on(ListenerEnum.UserUnpublished, callback);

    }

    public connectionState(callback: Function) {

        this._client.on(ListenerEnum.ConnectionStateChanged, callback);

    }

    public joinFallbackToProxy(callback: Function) {

        this._client.on(ListenerEnum.JoinFallbackToProxy, callback);

    }

    public networkQuality(callback: Function) {

        this._client.on(ListenerEnum.NetworkQuality, callback);

    }


}