import AgoraRTC from "agora-rtc-sdk-ng";
import { ActionParams } from "../action/type/ActionParams";
import { InitActionParams } from "../action/type/InitActionParams";
import { Context } from "../context/Context";
import { BaseOperation } from "./base/BaseOperation";
import { EOperationStatus } from "./enum/EOperationStatus";
import { EOperationType } from "./enum/EOperationType";
import { IOperation } from "./interface/IOperation";
const parseError = require('parse-error');

export class CreateClientOperation extends BaseOperation implements IOperation {

    constructor(context: Context){
        super(context);
        this.type=EOperationType.CREATE_CLIENT;
    }

    /*@overwrite*/
    public async handler(params ? : ActionParams) :Promise<string>{

        return new Promise( async (resolve, reject)=>{

            try {

                this.context.getDeterminants().setUpdating(true);

                let paramsObj : InitActionParams = Object.assign(params ? params : {});

                let client = await AgoraRTC.createClient(this.context.getResources().getConfigClient());

                AgoraRTC.setLogLevel(4);

                this.context.getResources().setClient(client);

                this.context.getDeterminants().setInit(paramsObj.init);

                this.status = EOperationStatus.PERFORMED;
            } catch (error) {
                this.addError(error);
                this.status = EOperationStatus.FAILED;
            }

            resolve(this.status);
        
        });

    }

   
}