import AgoraRTC from "agora-rtc-sdk-ng";
import { ActionParams } from "../action/type/ActionParams";
import { InitActionParams } from "../action/type/InitActionParams";
import { Context } from "../context/Context";
import { Listeners } from "../context/listeners/Listeners";
import { BaseOperation } from "./base/BaseOperation";
import { EOperationStatus } from "./enum/EOperationStatus";
import { EOperationType } from "./enum/EOperationType";
import { IOperation } from "./interface/IOperation";
const parseError = require('parse-error');

export class CreateListenersOperation extends BaseOperation implements IOperation{
  
    constructor(context: Context){
        super(context);
        this.type=EOperationType.CREATE_LISTENERS;
    }

    /*@overwrite*/
    public async handler(params ? : ActionParams) : Promise<string> {

        return new Promise( async (resolve, reject)=>{
            try {
                
                this.context.getDeterminants().setUpdating(true);

                let paramsObj : InitActionParams = Object.assign(params ? params : {});
                this.context.getResources().setListeners(new Listeners(this.context.getResources().getClient()));
                this.context.getDeterminants().setInit(paramsObj.init);
                this.status = EOperationStatus.PERFORMED;

            } catch (error) {
                this.addError(error);
                this.status = EOperationStatus.FAILED;               
            }

            resolve(this.status);

        });
       

    }

   
}