import AgoraRTC, { IAgoraRTCRemoteUser } from "agora-rtc-sdk-ng";
import { ActionParams } from "../action/type/ActionParams";
import { Context } from "../context/Context";
import { BaseOperation } from "./base/BaseOperation";
import { EOperationStatus } from "./enum/EOperationStatus";
import { EOperationType } from "./enum/EOperationType";
import { IOperation } from "./interface/IOperation";
const parseError = require('parse-error');

export class LeaveChannelOperation extends BaseOperation implements IOperation {

    constructor(context: Context){
        super(context);
        this.type=EOperationType.LEAVE_CHANNEL;
    }

    /*@overwrite*/
    public async handler(params ? : ActionParams) : Promise<string>{

        return new Promise( async (resolve, reject)=>{

            try {
                
                this.context.getDeterminants().setUpdating(true);

                let client = this.context.getResources().getClient();
                await client.leave();
                this.context.getResources().stopRecordVolumen();
                this.context.getDeterminants().setChannel("");
                this.status = EOperationStatus.PERFORMED;
            } catch (error) {
                this.addError(error);
                this.status = EOperationStatus.FAILED;
            }

            resolve(this.status);
        
        });

    }

   
}