import { ActionParams } from "../../action/type/ActionParams";
import { Context } from "../../context/Context";
import { CustomError } from "../../exception/CustomError";
import { EOperationStatus } from "../enum/EOperationStatus";
import { EOperationType } from "../enum/EOperationType";

export interface IOperation {
    type: EOperationType,
    status: EOperationStatus,
    datetime: Date,
    errors:Array<CustomError>,
    handler( params ? : ActionParams ): Promise<string>,
    setContext(value : Context):void,
    getContext():Context,
    addError(error: any):void
}